

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.Soup.Objects.ContentDecoder
    ( 

-- * Exported types
    ContentDecoder(..)                      ,
    IsContentDecoder                        ,
    toContentDecoder                        ,
    noContentDecoder                        ,


    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object
import {-# SOURCE #-} qualified GI.Soup.Interfaces.SessionFeature as Soup.SessionFeature

-- | Memory-managed wrapper type.
newtype ContentDecoder = ContentDecoder (ManagedPtr ContentDecoder)
foreign import ccall "soup_content_decoder_get_type"
    c_soup_content_decoder_get_type :: IO GType

instance GObject ContentDecoder where
    gobjectType = c_soup_content_decoder_get_type
    

-- | Type class for types which can be safely cast to `ContentDecoder`, for instance with `toContentDecoder`.
class (GObject o, O.IsDescendantOf ContentDecoder o) => IsContentDecoder o
instance (GObject o, O.IsDescendantOf ContentDecoder o) => IsContentDecoder o

instance O.HasParentTypes ContentDecoder
type instance O.ParentTypes ContentDecoder = '[GObject.Object.Object, Soup.SessionFeature.SessionFeature]

-- | Cast to `ContentDecoder`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toContentDecoder :: (MonadIO m, IsContentDecoder o) => o -> m ContentDecoder
toContentDecoder = liftIO . unsafeCastTo ContentDecoder

-- | A convenience alias for `Nothing` :: `Maybe` `ContentDecoder`.
noContentDecoder :: Maybe ContentDecoder
noContentDecoder = Nothing

#if ENABLE_OVERLOADING
type family ResolveContentDecoderMethod (t :: Symbol) (o :: *) :: * where
    ResolveContentDecoderMethod "addFeature" o = Soup.SessionFeature.SessionFeatureAddFeatureMethodInfo
    ResolveContentDecoderMethod "attach" o = Soup.SessionFeature.SessionFeatureAttachMethodInfo
    ResolveContentDecoderMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveContentDecoderMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveContentDecoderMethod "detach" o = Soup.SessionFeature.SessionFeatureDetachMethodInfo
    ResolveContentDecoderMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveContentDecoderMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveContentDecoderMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveContentDecoderMethod "hasFeature" o = Soup.SessionFeature.SessionFeatureHasFeatureMethodInfo
    ResolveContentDecoderMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveContentDecoderMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveContentDecoderMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveContentDecoderMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveContentDecoderMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveContentDecoderMethod "removeFeature" o = Soup.SessionFeature.SessionFeatureRemoveFeatureMethodInfo
    ResolveContentDecoderMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveContentDecoderMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveContentDecoderMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveContentDecoderMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveContentDecoderMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveContentDecoderMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveContentDecoderMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveContentDecoderMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveContentDecoderMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveContentDecoderMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveContentDecoderMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveContentDecoderMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveContentDecoderMethod t ContentDecoder, O.MethodInfo info ContentDecoder p) => OL.IsLabel t (ContentDecoder -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList ContentDecoder
type instance O.AttributeList ContentDecoder = ContentDecoderAttributeList
type ContentDecoderAttributeList = ('[ ] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
#endif

#if ENABLE_OVERLOADING
type instance O.SignalList ContentDecoder = ContentDecoderSignalList
type ContentDecoderSignalList = ('[ '("notify", GObject.Object.ObjectNotifySignalInfo)] :: [(Symbol, *)])

#endif


