

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.Soup.Objects.ProxyResolverDefault
    ( 

-- * Exported types
    ProxyResolverDefault(..)                ,
    IsProxyResolverDefault                  ,
    toProxyResolverDefault                  ,
    noProxyResolverDefault                  ,


 -- * Properties
-- ** gproxyResolver #attr:gproxyResolver#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    ProxyResolverDefaultGproxyResolverPropertyInfo,
#endif
    clearProxyResolverDefaultGproxyResolver ,
    constructProxyResolverDefaultGproxyResolver,
#if ENABLE_OVERLOADING
    proxyResolverDefaultGproxyResolver      ,
#endif
    setProxyResolverDefaultGproxyResolver   ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object
import qualified GI.Gio.Interfaces.ProxyResolver as Gio.ProxyResolver
import {-# SOURCE #-} qualified GI.Soup.Interfaces.ProxyURIResolver as Soup.ProxyURIResolver
import {-# SOURCE #-} qualified GI.Soup.Interfaces.SessionFeature as Soup.SessionFeature

-- | Memory-managed wrapper type.
newtype ProxyResolverDefault = ProxyResolverDefault (ManagedPtr ProxyResolverDefault)
foreign import ccall "soup_proxy_resolver_default_get_type"
    c_soup_proxy_resolver_default_get_type :: IO GType

instance GObject ProxyResolverDefault where
    gobjectType = c_soup_proxy_resolver_default_get_type
    

-- | Type class for types which can be safely cast to `ProxyResolverDefault`, for instance with `toProxyResolverDefault`.
class (GObject o, O.IsDescendantOf ProxyResolverDefault o) => IsProxyResolverDefault o
instance (GObject o, O.IsDescendantOf ProxyResolverDefault o) => IsProxyResolverDefault o

instance O.HasParentTypes ProxyResolverDefault
type instance O.ParentTypes ProxyResolverDefault = '[GObject.Object.Object, Soup.ProxyURIResolver.ProxyURIResolver, Soup.SessionFeature.SessionFeature]

-- | Cast to `ProxyResolverDefault`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toProxyResolverDefault :: (MonadIO m, IsProxyResolverDefault o) => o -> m ProxyResolverDefault
toProxyResolverDefault = liftIO . unsafeCastTo ProxyResolverDefault

-- | A convenience alias for `Nothing` :: `Maybe` `ProxyResolverDefault`.
noProxyResolverDefault :: Maybe ProxyResolverDefault
noProxyResolverDefault = Nothing

#if ENABLE_OVERLOADING
type family ResolveProxyResolverDefaultMethod (t :: Symbol) (o :: *) :: * where
    ResolveProxyResolverDefaultMethod "addFeature" o = Soup.SessionFeature.SessionFeatureAddFeatureMethodInfo
    ResolveProxyResolverDefaultMethod "attach" o = Soup.SessionFeature.SessionFeatureAttachMethodInfo
    ResolveProxyResolverDefaultMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveProxyResolverDefaultMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveProxyResolverDefaultMethod "detach" o = Soup.SessionFeature.SessionFeatureDetachMethodInfo
    ResolveProxyResolverDefaultMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveProxyResolverDefaultMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveProxyResolverDefaultMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveProxyResolverDefaultMethod "hasFeature" o = Soup.SessionFeature.SessionFeatureHasFeatureMethodInfo
    ResolveProxyResolverDefaultMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveProxyResolverDefaultMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveProxyResolverDefaultMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveProxyResolverDefaultMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveProxyResolverDefaultMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveProxyResolverDefaultMethod "removeFeature" o = Soup.SessionFeature.SessionFeatureRemoveFeatureMethodInfo
    ResolveProxyResolverDefaultMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveProxyResolverDefaultMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveProxyResolverDefaultMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveProxyResolverDefaultMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveProxyResolverDefaultMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveProxyResolverDefaultMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveProxyResolverDefaultMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveProxyResolverDefaultMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveProxyResolverDefaultMethod "getProxyUriAsync" o = Soup.ProxyURIResolver.ProxyURIResolverGetProxyUriAsyncMethodInfo
    ResolveProxyResolverDefaultMethod "getProxyUriSync" o = Soup.ProxyURIResolver.ProxyURIResolverGetProxyUriSyncMethodInfo
    ResolveProxyResolverDefaultMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveProxyResolverDefaultMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveProxyResolverDefaultMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveProxyResolverDefaultMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveProxyResolverDefaultMethod t ProxyResolverDefault, O.MethodInfo info ProxyResolverDefault p) => OL.IsLabel t (ProxyResolverDefault -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

-- VVV Prop "gproxy-resolver"
   -- Type: TInterface (Name {namespace = "Gio", name = "ProxyResolver"})
   -- Flags: [PropertyWritable]
   -- Nullable: (Nothing,Nothing)

{- |
Set the value of the “@gproxy-resolver@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' proxyResolverDefault [ #gproxyResolver 'Data.GI.Base.Attributes.:=' value ]
@
-}
setProxyResolverDefaultGproxyResolver :: (MonadIO m, IsProxyResolverDefault o, Gio.ProxyResolver.IsProxyResolver a) => o -> a -> m ()
setProxyResolverDefaultGproxyResolver obj val = liftIO $ B.Properties.setObjectPropertyObject obj "gproxy-resolver" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@gproxy-resolver@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructProxyResolverDefaultGproxyResolver :: (IsProxyResolverDefault o, Gio.ProxyResolver.IsProxyResolver a) => a -> IO (GValueConstruct o)
constructProxyResolverDefaultGproxyResolver val = B.Properties.constructObjectPropertyObject "gproxy-resolver" (Just val)

{- |
Set the value of the “@gproxy-resolver@” property to `Nothing`.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.clear' #gproxyResolver
@
-}
clearProxyResolverDefaultGproxyResolver :: (MonadIO m, IsProxyResolverDefault o) => o -> m ()
clearProxyResolverDefaultGproxyResolver obj = liftIO $ B.Properties.setObjectPropertyObject obj "gproxy-resolver" (Nothing :: Maybe Gio.ProxyResolver.ProxyResolver)

#if ENABLE_OVERLOADING
data ProxyResolverDefaultGproxyResolverPropertyInfo
instance AttrInfo ProxyResolverDefaultGproxyResolverPropertyInfo where
    type AttrAllowedOps ProxyResolverDefaultGproxyResolverPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrClear]
    type AttrSetTypeConstraint ProxyResolverDefaultGproxyResolverPropertyInfo = Gio.ProxyResolver.IsProxyResolver
    type AttrBaseTypeConstraint ProxyResolverDefaultGproxyResolverPropertyInfo = IsProxyResolverDefault
    type AttrGetType ProxyResolverDefaultGproxyResolverPropertyInfo = ()
    type AttrLabel ProxyResolverDefaultGproxyResolverPropertyInfo = "gproxy-resolver"
    type AttrOrigin ProxyResolverDefaultGproxyResolverPropertyInfo = ProxyResolverDefault
    attrGet _ = undefined
    attrSet _ = setProxyResolverDefaultGproxyResolver
    attrConstruct _ = constructProxyResolverDefaultGproxyResolver
    attrClear _ = clearProxyResolverDefaultGproxyResolver
#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList ProxyResolverDefault
type instance O.AttributeList ProxyResolverDefault = ProxyResolverDefaultAttributeList
type ProxyResolverDefaultAttributeList = ('[ '("gproxyResolver", ProxyResolverDefaultGproxyResolverPropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
proxyResolverDefaultGproxyResolver :: AttrLabelProxy "gproxyResolver"
proxyResolverDefaultGproxyResolver = AttrLabelProxy

#endif

#if ENABLE_OVERLOADING
type instance O.SignalList ProxyResolverDefault = ProxyResolverDefaultSignalList
type ProxyResolverDefaultSignalList = ('[ '("notify", GObject.Object.ObjectNotifySignalInfo)] :: [(Symbol, *)])

#endif


