

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.Soup.Objects.RequestData
    ( 

-- * Exported types
    RequestData(..)                         ,
    IsRequestData                           ,
    toRequestData                           ,
    noRequestData                           ,


    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object
import qualified GI.Gio.Interfaces.Initable as Gio.Initable
import {-# SOURCE #-} qualified GI.Soup.Objects.Request as Soup.Request

-- | Memory-managed wrapper type.
newtype RequestData = RequestData (ManagedPtr RequestData)
foreign import ccall "soup_request_data_get_type"
    c_soup_request_data_get_type :: IO GType

instance GObject RequestData where
    gobjectType = c_soup_request_data_get_type
    

-- | Type class for types which can be safely cast to `RequestData`, for instance with `toRequestData`.
class (GObject o, O.IsDescendantOf RequestData o) => IsRequestData o
instance (GObject o, O.IsDescendantOf RequestData o) => IsRequestData o

instance O.HasParentTypes RequestData
type instance O.ParentTypes RequestData = '[Soup.Request.Request, GObject.Object.Object, Gio.Initable.Initable]

-- | Cast to `RequestData`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toRequestData :: (MonadIO m, IsRequestData o) => o -> m RequestData
toRequestData = liftIO . unsafeCastTo RequestData

-- | A convenience alias for `Nothing` :: `Maybe` `RequestData`.
noRequestData :: Maybe RequestData
noRequestData = Nothing

#if ENABLE_OVERLOADING
type family ResolveRequestDataMethod (t :: Symbol) (o :: *) :: * where
    ResolveRequestDataMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveRequestDataMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveRequestDataMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveRequestDataMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveRequestDataMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveRequestDataMethod "init" o = Gio.Initable.InitableInitMethodInfo
    ResolveRequestDataMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveRequestDataMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveRequestDataMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveRequestDataMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveRequestDataMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveRequestDataMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveRequestDataMethod "send" o = Soup.Request.RequestSendMethodInfo
    ResolveRequestDataMethod "sendAsync" o = Soup.Request.RequestSendAsyncMethodInfo
    ResolveRequestDataMethod "sendFinish" o = Soup.Request.RequestSendFinishMethodInfo
    ResolveRequestDataMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveRequestDataMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveRequestDataMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveRequestDataMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveRequestDataMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveRequestDataMethod "getContentLength" o = Soup.Request.RequestGetContentLengthMethodInfo
    ResolveRequestDataMethod "getContentType" o = Soup.Request.RequestGetContentTypeMethodInfo
    ResolveRequestDataMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveRequestDataMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveRequestDataMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveRequestDataMethod "getSession" o = Soup.Request.RequestGetSessionMethodInfo
    ResolveRequestDataMethod "getUri" o = Soup.Request.RequestGetUriMethodInfo
    ResolveRequestDataMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveRequestDataMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveRequestDataMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveRequestDataMethod t RequestData, O.MethodInfo info RequestData p) => OL.IsLabel t (RequestData -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList RequestData
type instance O.AttributeList RequestData = RequestDataAttributeList
type RequestDataAttributeList = ('[ '("session", Soup.Request.RequestSessionPropertyInfo), '("uri", Soup.Request.RequestUriPropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
#endif

#if ENABLE_OVERLOADING
type instance O.SignalList RequestData = RequestDataSignalList
type RequestDataSignalList = ('[ '("notify", GObject.Object.ObjectNotifySignalInfo)] :: [(Symbol, *)])

#endif


